/* plural cam curves drawing                        1997.1.10 */
/* file : curv1 - curv6 : n, Y(T) V(T)  A(T) */
#include <math.h>
#include <stdio.h>
#include <dos.h>
#include <conio.h>
#include <graph.h>

char fname[9][32]={"curv0","curv1","curv2","curv3","curv4","curv5","curv6"};
float kx=200,ky=-200,kv=-80,ka=-25 ,x00=200,y00=350,zero=0;
float th[201],lift[201][3];
int n=96,d1,d2,dd[10],m;
line(x1,y1,x2,y2,ch2) float x1,y1,x2,y2; int ch2;
  {int p1,q1,p2,q2;
   p1=x00+kx*x1;   p2=x00+kx*x2;
   if(ch2==0)  {q1=y00+ky*y1;   q2=y00+ky*y2;}
   if(ch2==1)  {q1=y00+kv*y1;   q2=y00+kv*y2;}
   if(ch2==2)  {q1=200+ka*y1;   q2=200+ka*y2;}
   _moveto(p1,q1);    _lineto(p2,q2);
  }
circle(x,y,r)  float x,y,r;
  {int p1,q1,p2,q2;
   p1=x00+kx*(x+r); q1=y00+ky*(y+r);   p2=x00+kx*(x-r); q2=y00+ky*(y-r);
   _ellipse(_GBORDER,p1,q1,p2,q2);
  }
axis()
  {line(0.,0.,1.5,0.,d2);       line(0.,0.,0.,1.2,d2);
   line(0.,1.,1.5,1.,d2);       line(1.,0.,1.,1.2,d2);
   line(0.,0.5,0.05,0.5,d2);    line(0.5,0.,0.5,0.05,d2);
  }
axisv()
  {int i;
   line(0.,0.,1.5,0.,d2);    line(0.,0.,0.,4.2,d2);   line(1.,0.,1.,4.2,d2);
   line(0.5,0.,0.5,0.08,d2);
   for(i=1;i<=4;i++)   line(0.,1.*i,0.05,1.*i,d2);
  }
axisa()
  {int i;
   line(0.,0.,1.5,0.,d2); line(0.,-6.2,0.,6.2,d2); line(1.,-6.2,1.,6.2,d2);
   line(0.5,0.,0.5,0.1,d2);
   for(i=-6;i<=6;i++)   line(0.,1.*i,0.05,1.*i,d2);
  }

/* -------------------------------------------------------------------- */
main()
  {int i,j,k;
   FILE *fp[10];
   _setvideomode(_98RESS8COLOR);
   /*_setactivepage(0);*/	/*cleardevice();*/
   /*_setactivepage(1);*/	/*cleardevice();*/
   _clearscreen(_GCLEARSCREEN);   _setcolor(6);
p1:printf("\nPlural cam curves drawing");
p6:printf("\nKasane-gaki how many curve?  0:stop. m="); scanf("%d",&m);
   if(m==0) goto p8;
   printf("\nWhich curve?  ");
   printf("\n0:parabolic  ");
   printf("\n1:sine           2:cycloid  3:modified trapezoid");
   printf("\n4:modified sine  5:Gutmann  6:modifed const vel.");
   printf("\n7:2-interpoints \n");
   for(j=1;j<=m;j++) {printf("j=%d, curve number=",j);  scanf("%d",&dd[j]);}
   printf("\nWhich curve display?  0:Y(T), 1:V(T), 2:A(T)  ");
   scanf("%d",&d2);
p7:_clearscreen(_GCLEARSCREEN);   _setcolor(6);
   if(d2==0)  axis();    if(d2==1)  axisv();    if(d2==2)  axisa();
   for(j=1;j<=m;j++)
     {_setcolor(j+2);
      fp[j]=fopen(fname[dd[j]],"rt");      fscanf(fp[j],"%d",&n);
      printf("\nn=%d",n);
      fscanf(fp[j],"%f %f %f",&lift[0][0],&lift[0][1],&lift[0][2]);
      th[0]=0;
      for(i=1;i<=n;i++)
        {th[i]=i*1.0/n;
         fscanf(fp[j],"%f %f %f",&lift[i][0],&lift[i][1],&lift[i][2]);
         line(th[i-1],lift[i-1][d2],th[i],lift[i][d2],d2);
/*
printf("\n%6.3f %8.5f %8.5f %8.5f",th[i],lift[i][0],lift[i][1],lift[i][2]);
*/
         getch();
        }
      fclose(fp[j]);
     }
   printf("\nOther curve?  0:Y(T), 1:V(T), 2:A(T), 3:no  ");
   scanf("%d",&d2); if(d2<3) goto p7;
p8:;
  }
